//------------------------------------------------------------------------
// File name...............: OperatorTest.cpp
// Programmr..............: Bjrk Boye Busch
// Beskrivelse.............: Eksempler p definition og brug af funktions
//							 og operator overload
//------------------------------------------------------------------------

#include "Operator.h"

//-----------------------------------------------------------------------------------------
// afprvnings eksempler		
//-----------------------------------------------------------------------------------------

void main()
{
	//---------------------------------------------------------------
	// Test af constructors og assignment 
	//---------------------------------------------------------------
	
	CxTid Tida(10);				// alm. constructor
	CxTid Tidb(10);
	CxTid Tidc(17);
	CxTid Tidd(Tida);			// copy constructor
	cout << "\nTida " << Tida;
	CxTid Tide = Tida;			// NB. copy constructor
	cout << "\nTide " << Tide;

	Tidd = Tida;				// assignment  CxTid = CxTid
	cout << "\nTida " << Tida;

	Tida = 17;					// assignment  CxTid = int
	cout << "Tida " << Tida;

	{int x;	cin >> x;}// vent	

	//---------------------------------------------------------------
	// Test af ostream og istream operatorer
	//---------------------------------------------------------------
	
	cout << "\nTida " << Tida;	// brug af ostream overload

	cin >> Tida;				// brug af istream overload

	cout << "\nTida " << Tida << "\n";

	{int x;	cin >> x;}// vent	


	//---------------------------------------------------------------
	// Test af test-operatorer
	//---------------------------------------------------------------
	cout << "Tida==Tidb ? " << (Tida==Tidb) << "\n"; // brug af CxTid==CxTid
	cout << "Tida==Tidc ? " << (Tida==Tidc) << "\n"; // brug af CxTid==CxTid
	cout << "Tida==17   ? " << (Tida==17) << "\n";	 // brug af CxTid==int
	cout << "17==Tida   ? " << (17==Tida) << "\n";	 // brug af int==CxTid

	
	{int x;	cin >> x;}// vent	

	
	
	//---------------------------------------------------------------
	// Test af regneoperatorer med 1 operant
	//---------------------------------------------------------------
	cout << "\nTida " << Tida;
	cout << "\n(++Tida)  " << (++Tida);		// brug af ++CxTid : prefix
	cout << "\nTida " << Tida;
	cout << "\n(Tida++)  " << (Tida++);		// brug af CxTid++ : postfix
	cout << "\nTida " << Tida;

	{int x;	cin >> x;}// vent	

	//---------------------------------------------------------------
	// Test af regneoperatorer med 2 operanter
	//---------------------------------------------------------------
	CxTid Ta(1);
	CxTid Tb(2);
	cout << "\n------------------------------";
	cout << "\n(Ta+Tb)  " << (Ta+Tb) << " Ta="<<Ta<<" Tb="<<Tb;	// brug af CxTid+CxTid
	cout << "\n------------------------------";
	cout << "\n(Ta+10)  " << (Ta+10) << " Ta="<<Ta<<" Tb="<<Tb;	// brug af CxTid+int
	cout << "\n------------------------------";
	cout << "\n(10+Tb)  " << (10+Tb) << " Ta="<<Ta<<" Tb="<<Tb;	// brug af int+CxTid

	{int x;	cin >> x;}// vent	
}
